/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.stimmzettel.boundary;

import de.ivu.elect.business.stimmzettel.entity.Stimmzettel;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class StimmzettelDAO extends AbstractStimmzettelDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Stimmzettel stimmzettel){
    getEntityManager().persist(stimmzettel);
  }

  public void remove(Stimmzettel stimmzettel){
    getEntityManager().remove(stimmzettel);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                            
        /**
        * Name: GebietAndStimmzettelteamNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet=?1 AND o.stimmzettelTeam = ?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Stimmzettel> findByGebietAndStimmzettelteam( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByGebietAndStimmzettelteam" ,  gebiet ,  stimmzettelTeam  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGebietAndStimmzettelteam( gebiet ,  stimmzettelTeam  ));
        }
        return (java.util.List<Stimmzettel>) cached;
        }
            return super.findByGebietAndStimmzettelteam( gebiet ,  stimmzettelTeam  );
            }
                                                                        
        /**
        * Name: GebietNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Stimmzettel> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByGebiet" ,  gebiet  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGebiet( gebiet  ));
        }
        return (java.util.List<Stimmzettel>) cached;
        }
            return super.findByGebiet( gebiet  );
            }
                                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet.wahl=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Stimmzettel> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<Stimmzettel>) cached;
        }
            return super.findByWahl( wahl  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}